// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_nav_msgs:msg/IwsCmdVRAT.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__IWS_CMD_VRAT__STRUCT_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__IWS_CMD_VRAT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_nav_msgs__msg__IwsCmdVRAT __attribute__((deprecated))
#else
# define DEPRECATED__tuw_nav_msgs__msg__IwsCmdVRAT __declspec(deprecated)
#endif

namespace tuw_nav_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct IwsCmdVRAT_
{
  using Type = IwsCmdVRAT_<ContainerAllocator>;

  explicit IwsCmdVRAT_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->v = 0.0;
      this->rho = 0.0;
      this->phi = 0.0;
      this->delta_t = 0.0;
    }
  }

  explicit IwsCmdVRAT_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->v = 0.0;
      this->rho = 0.0;
      this->phi = 0.0;
      this->delta_t = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _v_type =
    double;
  _v_type v;
  using _rho_type =
    double;
  _rho_type rho;
  using _phi_type =
    double;
  _phi_type phi;
  using _delta_t_type =
    double;
  _delta_t_type delta_t;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__v(
    const double & _arg)
  {
    this->v = _arg;
    return *this;
  }
  Type & set__rho(
    const double & _arg)
  {
    this->rho = _arg;
    return *this;
  }
  Type & set__phi(
    const double & _arg)
  {
    this->phi = _arg;
    return *this;
  }
  Type & set__delta_t(
    const double & _arg)
  {
    this->delta_t = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_nav_msgs__msg__IwsCmdVRAT
    std::shared_ptr<tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_nav_msgs__msg__IwsCmdVRAT
    std::shared_ptr<tuw_nav_msgs::msg::IwsCmdVRAT_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IwsCmdVRAT_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->v != other.v) {
      return false;
    }
    if (this->rho != other.rho) {
      return false;
    }
    if (this->phi != other.phi) {
      return false;
    }
    if (this->delta_t != other.delta_t) {
      return false;
    }
    return true;
  }
  bool operator!=(const IwsCmdVRAT_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IwsCmdVRAT_

// alias to use template instance with default allocator
using IwsCmdVRAT =
  tuw_nav_msgs::msg::IwsCmdVRAT_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_nav_msgs

#endif  // TUW_NAV_MSGS__MSG__DETAIL__IWS_CMD_VRAT__STRUCT_HPP_
