// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_nav_msgs:msg/IwsCmdVRATVec.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__IWS_CMD_VRAT_VEC__TRAITS_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__IWS_CMD_VRAT_VEC__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_nav_msgs/msg/detail/iws_cmd_vrat_vec__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace tuw_nav_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const IwsCmdVRATVec & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: v
  {
    if (msg.v.size() == 0) {
      out << "v: []";
    } else {
      out << "v: [";
      size_t pending_items = msg.v.size();
      for (auto item : msg.v) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: rho
  {
    if (msg.rho.size() == 0) {
      out << "rho: []";
    } else {
      out << "rho: [";
      size_t pending_items = msg.rho.size();
      for (auto item : msg.rho) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: phi
  {
    if (msg.phi.size() == 0) {
      out << "phi: []";
    } else {
      out << "phi: [";
      size_t pending_items = msg.phi.size();
      for (auto item : msg.phi) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: delta_t
  {
    if (msg.delta_t.size() == 0) {
      out << "delta_t: []";
    } else {
      out << "delta_t: [";
      size_t pending_items = msg.delta_t.size();
      for (auto item : msg.delta_t) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: state0
  {
    if (msg.state0.size() == 0) {
      out << "state0: []";
    } else {
      out << "state0: [";
      size_t pending_items = msg.state0.size();
      for (auto item : msg.state0) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const IwsCmdVRATVec & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: v
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.v.size() == 0) {
      out << "v: []\n";
    } else {
      out << "v:\n";
      for (auto item : msg.v) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: rho
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.rho.size() == 0) {
      out << "rho: []\n";
    } else {
      out << "rho:\n";
      for (auto item : msg.rho) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: phi
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.phi.size() == 0) {
      out << "phi: []\n";
    } else {
      out << "phi:\n";
      for (auto item : msg.phi) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: delta_t
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.delta_t.size() == 0) {
      out << "delta_t: []\n";
    } else {
      out << "delta_t:\n";
      for (auto item : msg.delta_t) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: state0
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.state0.size() == 0) {
      out << "state0: []\n";
    } else {
      out << "state0:\n";
      for (auto item : msg.state0) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const IwsCmdVRATVec & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_nav_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_nav_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_nav_msgs::msg::IwsCmdVRATVec & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_nav_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_nav_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_nav_msgs::msg::IwsCmdVRATVec & msg)
{
  return tuw_nav_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_nav_msgs::msg::IwsCmdVRATVec>()
{
  return "tuw_nav_msgs::msg::IwsCmdVRATVec";
}

template<>
inline const char * name<tuw_nav_msgs::msg::IwsCmdVRATVec>()
{
  return "tuw_nav_msgs/msg/IwsCmdVRATVec";
}

template<>
struct has_fixed_size<tuw_nav_msgs::msg::IwsCmdVRATVec>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_nav_msgs::msg::IwsCmdVRATVec>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_nav_msgs::msg::IwsCmdVRATVec>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_NAV_MSGS__MSG__DETAIL__IWS_CMD_VRAT_VEC__TRAITS_HPP_
