// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_nav_msgs:msg/RouteSegment.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_H_
#define TUW_NAV_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'start'
// Member 'end'
// Member 'center'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in msg/RouteSegment in the package tuw_nav_msgs.
typedef struct tuw_nav_msgs__msg__RouteSegment
{
  /// Segment id
  uint32_t id;
  /// Segment type
  /// NA      = 0
  /// LINE    = 1
  /// ARC     = 2
  /// SPIROS  = 3
  /// SPLINE  = 4
  uint8_t type;
  /// Segment orientation
  /// CLOCKWISE  = 0
  /// COUNTER_CLOCKWISE  = 1
  uint8_t orientation;
  /// Motion type
  /// NA = 0
  /// FLAT = 1
  /// DWA_SLOW = 2
  /// DWA_FAST = 3
  /// MPC_SLOW = 4
  /// MPC_FAST = 5
  /// PI_SLOW = 6
  /// PI_FAST = 7
  uint8_t motion_type;
  geometry_msgs__msg__Pose start;
  geometry_msgs__msg__Pose end;
  geometry_msgs__msg__Pose center;
  int8_t level;
} tuw_nav_msgs__msg__RouteSegment;

// Struct for a sequence of tuw_nav_msgs__msg__RouteSegment.
typedef struct tuw_nav_msgs__msg__RouteSegment__Sequence
{
  tuw_nav_msgs__msg__RouteSegment * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_nav_msgs__msg__RouteSegment__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_NAV_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_H_
