// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_nav_msgs:msg/Float64Array.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__FLOAT64_ARRAY__TRAITS_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__FLOAT64_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_nav_msgs/msg/detail/float64_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace tuw_nav_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Float64Array & msg,
  std::ostream & out)
{
  out << "{";
  // member: val
  {
    if (msg.val.size() == 0) {
      out << "val: []";
    } else {
      out << "val: [";
      size_t pending_items = msg.val.size();
      for (auto item : msg.val) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Float64Array & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: val
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.val.size() == 0) {
      out << "val: []\n";
    } else {
      out << "val:\n";
      for (auto item : msg.val) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Float64Array & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_nav_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_nav_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_nav_msgs::msg::Float64Array & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_nav_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_nav_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_nav_msgs::msg::Float64Array & msg)
{
  return tuw_nav_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_nav_msgs::msg::Float64Array>()
{
  return "tuw_nav_msgs::msg::Float64Array";
}

template<>
inline const char * name<tuw_nav_msgs::msg::Float64Array>()
{
  return "tuw_nav_msgs/msg/Float64Array";
}

template<>
struct has_fixed_size<tuw_nav_msgs::msg::Float64Array>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_nav_msgs::msg::Float64Array>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_nav_msgs::msg::Float64Array>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_NAV_MSGS__MSG__DETAIL__FLOAT64_ARRAY__TRAITS_HPP_
