// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_nav_msgs:msg/JointsIWS.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__JOINTS_IWS__STRUCT_H_
#define TUW_NAV_MSGS__MSG__DETAIL__JOINTS_IWS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'type_steering'
// Member 'type_revolute'
#include "rosidl_runtime_c/string.h"
// Member 'steering'
// Member 'revolute'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/JointsIWS in the package tuw_nav_msgs.
/**
  * Message for sensing/control of an indepenend N wheel steering platform
 */
typedef struct tuw_nav_msgs__msg__JointsIWS
{
  std_msgs__msg__Header header;
  /// the type defines the usage and units such as cmd_torque, cmd_acceleration, cmd_velocity, cmd_position, measured_torque, measured_acceleration, measured_velocity, measured_position
  rosidl_runtime_c__String type_steering;
  rosidl_runtime_c__String type_revolute;
  /// actual sensing/control variables of the defined type
  rosidl_runtime_c__double__Sequence steering;
  rosidl_runtime_c__double__Sequence revolute;
} tuw_nav_msgs__msg__JointsIWS;

// Struct for a sequence of tuw_nav_msgs__msg__JointsIWS.
typedef struct tuw_nav_msgs__msg__JointsIWS__Sequence
{
  tuw_nav_msgs__msg__JointsIWS * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_nav_msgs__msg__JointsIWS__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_NAV_MSGS__MSG__DETAIL__JOINTS_IWS__STRUCT_H_
